/*
KyotoEBMT Example-Based Machine Translation System
Copyright (C) 2014 John Richardson, Fabien Cromieres, 
Toshiaki Nakazawa and Sadao Kurohashi

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

/*! \file
    \ingroup data_creation_group
    \brief Create data from XML files.
*/

#include "DatasGenerationFromXML.hpp"
//#include "boost/program_options.hpp"

//namespace po = boost::program_options;

int main(int argc, char *argv[])
    {
    
    if (argc<2)
        {
        std::cerr<<"Usage: "<<argv[0]<<" /path/to/database"<< " /path/to/xmlfile"<<std::endl;
        return 1;
        }
        
    std::string datapath(argv[1]);
    std::vector<std::string> xmlFilenameList;
        
    if (argc==2)
        {
        
//        std::copy(std::istream_iterator<std::string>(std::cin),std::istream_iterator<std::string>(),std::back_inserter(xmlFilenameList));
        std::string line;
        while(std::getline(std::cin,line))
            {
            //std::getline(std::cin,line);
            if ( line.length()==0 ) continue;
            //std::cout<<"R"<<std::endl;
            //std::cout<<line<<std::endl;
            xmlFilenameList.push_back(line);
            }

        }
    else
        {
        //std::transform(argv+1,argv+argc,std::back_inserter(xmlFilenameList),std::string);
        std::copy(argv+2,argv+argc,std::back_inserter(xmlFilenameList));
        }
    
    if (xmlFilenameList.size()==0)
        {
        std::cerr<<"Error: no xml file specified"<<std::endl;
        return 1;
        }
    
    std::cout<<"Generating database "<<datapath<<" from "<<xmlFilenameList.size()<< " xml files :"<<std::endl;
    std::cout<<"   "<<xmlFilenameList[0]<<"  ...  "<<xmlFilenameList[xmlFilenameList.size()-1]<<std::endl;
    //std::cout<<"before generateDatas"<<std::endl;
    generateDatas(xmlFilenameList,datapath.c_str());
    //std::cout<<"after generateDatas"<<std::endl;
    
    }
    
    
/*
    // Declare the supported options.
    po::options_description desc("Allowed options");
    desc.add_options()
        ("help", "produce help message")
        ("database",po::value<std::string>(), "specify database name")
        ("xml",po::value<std::string>(), "specify source xml file")
        //("compression", po::value<int>(), "set compression level")
    ;

    po::variables_map vm;
    po::store(po::parse_command_line(argc, argv, desc), vm);
    po::notify(vm);    

    if (vm.count("help")) {
        std::cout << desc << "\n";
        return 1;
    }

    if (!vm.count("database")) {
        std::cerr << "Option database must be specified" << "\n";
        return 1;        
    }
    
    if (!vm.count("xml")) {
        std::cerr << "Option xml must be specified" << "\n";
        return 1;        
    }
    std::string xmlFilename=vm["xml"].as<std::string>();
    std::string dbPathPrefix=vm["database"].as<std::string>();
*/
