/*
KyotoEBMT Example-Based Machine Translation System
Copyright (C) 2014 John Richardson, Fabien Cromieres, 
Toshiaki Nakazawa and Sadao Kurohashi

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

/*! \file
    \ingroup data_creation_group
    \brief Utility struct for storing the filename patterns for each type of file used by the system.
*/

#include <string>

#ifndef _HPP_DEFAULT_DATAPATH_
#define _HPP_DEFAULT_DATAPATH_

struct DataFilenameSufixes
    {
    std::string invertedIndex;
    std::string targetInfo;
    std::string indexer;
    std::string treeToId;
    std::string mostFrequentLabel;
    
    DataFilenameSufixes(std::string side)
        {
        invertedIndex=std::string("_occidx")+side+std::string(".boost_CP");
        targetInfo=std::string("_TargetInfoList")+side+std::string(".boost_serialization");
        indexer=std::string(".idx")+side+std::string(".boost");
        treeToId=std::string("_numTreeToId.boost");
        mostFrequentLabel=std::string("_MostFrequentIndexes.")+side+std::string(".boost");        
        }
    
    static std::string getInvertedIndexFilename(std::string datapath,std::string side)
        {
        return datapath+std::string("_occidx")+side+std::string(".boost_CP");
        }

    static std::string getTargetInfoFilename(std::string datapath,std::string side)
        {
        return datapath+std::string("_TargetInfoList")+side+std::string(".boost_serialization");
        }

    static std::string getLabelIndexerFilename(std::string datapath,std::string side)
        {
        return datapath+std::string(".idx")+side+std::string(".boost");
        }

    static std::string getNumTreeToIdFilename(std::string datapath)
        {
        return datapath+std::string("_numTreeToId.boost");
        }

    static std::string getMostFrequentLabelFilename(std::string datapath,std::string side)
        {
        return datapath+std::string("_MostFrequentIndexes.")+side+std::string(".boost"); 
        }
    
    static std::string getAdditionalDatasFilename(std::string datapath,std::string side)
        {
        return datapath+std::string("_AddDatas.")+side+std::string(".boost"); 
        }

    static std::string getAdditionalDatasFilenameV2(std::string datapath,std::string side)
        {
        return datapath+std::string("_AddDatas.")+side+std::string(".boostV2"); 
        }
        
    };
    
#endif

