/*
KyotoEBMT Example-Based Machine Translation System
Copyright (C) 2014 John Richardson, Fabien Cromieres, 
Toshiaki Nakazawa and Sadao Kurohashi

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

/*! \file
    \ingroup server_group
    \brief Some constants that should be kept in sync with client and server.
*/

#ifndef HPP_TR_CLIENT_SERVER_COMMON_VALUES
#define HPP_TR_CLIENT_SERVER_COMMON_VALUES

const size_t maxAllowedMessageLengthForSeqOfPos=1000;
const size_t maxAllowedMessageLengthForMatching=10000;

const size_t nbBytesForEncodingMessageLength=4;

size_t decodeMessageLength(unsigned char *buffer)
    {
    //std::cerr<<">>decodeMessageLength"<<std::endl;
    size_t result=0;
    for (int i=0;i<(int)nbBytesForEncodingMessageLength;++i)
        {
        
        //std::cerr<<"buffer["<<i<<"] ="<<(int)buffer[i]<<std::endl;
        result+=buffer[i];
        if (i!=nbBytesForEncodingMessageLength-1)
            {
            result=result<<8;
            }
         //std::cerr<<"result: "<<result<<std::endl;
        }
    //std::cerr<<"<<decodeMessageLength: "<<result<<std::endl;
    return result;
    }
  
void encodeMessageLength(size_t length,unsigned char *buffer)
    {
    //std::cerr<<">>encodeMessageLength: "<<length<<std::endl;
    for (int i=nbBytesForEncodingMessageLength-1;i>=0;--i) // beware: bug if i is size_t and not int....
        {
        //std::cerr<<"buffer["<<i<<"] <-"<<(length & 0xFF)<<std::endl;
        buffer[i]=(length & 0xFF);
        length=length>>8;
        }
    assert(length==0);
    //std::cerr<<"<<encodeMessageLength"<<std::endl;
    }  


#endif

