#!/bin/bash

# Compile glog
cd glog
./configure --prefix="$PWD/build"
make
make install
cd ..

# Compile KenLM
cd KenLM
rm {lm,util}/*.o 2>/dev/null
set -e
CXXFLAGS="-I. -O3 -DNDEBUG -DKENLM_MAX_ORDER=7 -DHAVE_ICU $CXXFLAGS"
OBJECTS=""
for i in util/double-conversion/*.cc util/*.cc lm/*.cc ; do
  if [ "${i%test.cc}" == "$i" ] && [ "${i%main.cc}" == "$i" ]; then
    g++ $CXXFLAGS -c $i -o ${i%.cc}.o
    OBJECTS="$OBJECTS $KENLM_DIR/${i%.cc}.o"
  fi
done
cd ..

# Link urwid
ln -s ../libs/urwid/urwid ../tuning/urwid
