/*
KyotoEBMT Example-Based Machine Translation System
Copyright (C) 2014 John Richardson, Fabien Cromieres, 
Toshiaki Nakazawa and Sadao Kurohashi

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

/*! @file
  This file contains functions for Japanese as the source language and
  Chinese as the target language.
*/
#ifndef TM_PROCESSOR_JA_ZH_INCLUDED
#define TM_PROCESSOR_JA_ZH_INCLUDED

#include <string>
#include "pair.hpp"

class TMProcessorPairJaZh : public TMProcessorPair {
  public:
    virtual ~TMProcessorPairJaZh() {}

    virtual std::string num_translation(const std::string& content, const std::string& num, const std::string& type) const;
    virtual bool is_skip_translation(const DtreeNode *w) const;
};

#endif
