/*
KyotoEBMT Example-Based Machine Translation System
Copyright (C) 2014 John Richardson, Fabien Cromieres, 
Toshiaki Nakazawa and Sadao Kurohashi

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

#include <boost/regex.hpp>
#include <string>
#include "pair.hpp"

std::string TMProcessorPair::num_translation(const std::string& content, const std::string& num, const std::string& type) const {
    std::string new_content = content;
    std::cerr << content << " " << num << std::endl;
    const boost::regex reg("[\\d\\-\\.\\,]*\\d");
    std::string tmp = boost::regex_replace(content, reg, num);
    if (tmp != content) {
        new_content = tmp;
    }
    return new_content;
}

bool TMProcessorPair::is_skip_translation(const DtreeNode *w) const {
    return false;
}

