/*
KyotoEBMT Example-Based Machine Translation System
Copyright (C) 2014 John Richardson, Fabien Cromieres, 
Toshiaki Nakazawa and Sadao Kurohashi

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

/*! @file
  This file contains default functions for language-pair-dependent TM processing.
*/
#ifndef TM_PROCESSOR_PAIR_INCLUDED
#define TM_PROCESSOR_PAIR_INCLUDED

#include <string>
#include "../tm.hpp"
#include "../dtree.hpp"
//#include "../hypothesis.hpp"

class TMProcessorPair {
  public:
    virtual ~TMProcessorPair() {}

    virtual std::string num_translation(const std::string& content, const std::string& num, const std::string& type) const;
    virtual bool is_skip_translation(const DtreeNode *w) const;
  protected:
    void strReplace(std::string& str, const std::string& from, const std::string& to) const {
        std::string::size_type pos = 0;
        while (pos = str.find(from, pos), pos != std::string::npos) {
            str.replace(pos, from.length(), to);
            pos += to.length();
        }
    }
};

#endif
