/*
KyotoEBMT Example-Based Machine Translation System
Copyright (C) 2014 John Richardson, Fabien Cromieres, 
Toshiaki Nakazawa and Sadao Kurohashi

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

#include <boost/regex.hpp>
#include <boost/regex/icu.hpp>
#include <string>
#include "zh_ja.hpp"

std::string TMProcessorPairZhJa::num_translation(const std::string& content, const std::string& num, const std::string& type) const {
    std::string num_tmp = num;
    strReplace(num_tmp, "0", "０");
    strReplace(num_tmp, "1", "１");
    strReplace(num_tmp, "2", "２");
    strReplace(num_tmp, "3", "３");
    strReplace(num_tmp, "4", "４");
    strReplace(num_tmp, "5", "５");
    strReplace(num_tmp, "6", "６");
    strReplace(num_tmp, "7", "７");
    strReplace(num_tmp, "8", "８");
    strReplace(num_tmp, "9", "９");
    strReplace(num_tmp, "-", "−");
    strReplace(num_tmp, ".", "．");
    strReplace(num_tmp, ",", "，");

    const boost::u32regex e = boost::make_u32regex("[０１２３４５６７８９一二三四五六七八九〇零十拾百千万億兆−．，]*[０１２３４５６７８９一二三四五六七八九〇零十拾百千万億兆]");
    UnicodeString unicode_content(content.c_str(), "utf-8");
    UnicodeString unicode_num_tmp(num_tmp.c_str(), "utf-8");
    UnicodeString unicode_result = boost::u32regex_replace(unicode_content, e, unicode_num_tmp, boost::format_first_only);
    int32_t convertedLength = unicode_result.extract(0, unicode_result.length(), 0, "utf-8"); 
    char* result_char = new char[convertedLength + 1];
    unicode_result.extract(0, unicode_result.length(), result_char, "utf-8"); 
    std::string result(result_char);
    return result;
}

