/*
KyotoEBMT Example-Based Machine Translation System
Copyright (C) 2014 John Richardson, Fabien Cromieres, 
Toshiaki Nakazawa and Sadao Kurohashi

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

#include "features_structs.hpp"

namespace latt {

std::ostream& operator<<(std::ostream& stream, const AdditiveFeaturesWeight& add) {
    stream << "AFW<" << " nb_w:" << add.nb_words_;
    stream << " nb_oov:" << add.nb_oov_;
    BOOST_FOREACH(const AdditiveFeaturesWeight::SparseMap::value_type& name_val, add.sparse_features_) {
        stream << " " << name_val.first << ":" << name_val.second;
    }
    stream << " >";
    return stream;
}

std::ostream& operator<<(std::ostream& stream, const AdditiveFeatures& add) {
    stream << "AF<" << " nb_w:" << add.nb_words_;
    stream << " nb_oov:" << add.nb_oov_;
    BOOST_FOREACH(const AdditiveFeatures::SparseMap::value_type& name_val, add.sparse_features_) {
        stream << " " << name_val.first << ":" << name_val.second;
    }
    if (add.has_impossible_edge_) stream << "#IMPOSSIBLE!#";
    stream << " >";
    return stream;
}

} // namespace latt
