/*
KyotoEBMT Example-Based Machine Translation System
Copyright (C) 2014 John Richardson, Fabien Cromieres, 
Toshiaki Nakazawa and Sadao Kurohashi

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

#include "lm_stream.hpp"

#include <iostream>
#include "lm/state.hh"

namespace lm {
namespace ngram {

std::ostream& operator<<(std::ostream& stream, const lm::ngram::State& state) {
    stream << "S<" << (unsigned int) state.length << "[";
    for (int i = 0; i < state.length; ++i) { //KENLM_MAX_ORDER - 1
        stream << state.words[i] << ":" << state.backoff[i] << ",";
    }
    stream << "]>";
    return stream;
}

std::ostream& operator<<(std::ostream& stream, const lm::ngram::Left& left) {
    stream << "L<" << (unsigned int) left.length << "(" << (left.full ? "F" : "N") << ")[";
    for (int i = 0; i < left.length; ++i) {
        stream << left.pointers[i] << ",";
    }
    stream << "]>";
    return stream;
}

std::ostream& operator<<(std::ostream& stream, const lm::ngram::ChartState& state) {
    stream << "{" << state.left << "|" << state.right << "}";
    return stream;
}

} // namespace lm
} // namespace ngram

