/*
KyotoEBMT Example-Based Machine Translation System
Copyright (C) 2014 John Richardson, Fabien Cromieres, 
Toshiaki Nakazawa and Sadao Kurohashi

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef DICTIONARY_HPP
#define DICTIONARY_HPP

#include <fstream>
#include <iostream>
#include <string>
#include <map>
#include "params.hpp"

class Dictionary {
  private:
    std::map<std::string, std::string> dic_;
  public:
    const std::map<std::string, std::string> get_dic() const {return dic_;}
    std::string query(const std::string &word) const;
    explicit Dictionary(const std::string &filename);
    // Default constructor (mainly for allowing instanciating Translator object without 
    // dictionary for hypothesis input mode.
    Dictionary() {}
};

#endif
