/*
KyotoEBMT Example-Based Machine Translation System
Copyright (C) 2014 John Richardson, Fabien Cromieres, 
Toshiaki Nakazawa and Sadao Kurohashi

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef LEXICAL_TRANSLATION_SCORER_INCLUDED
#define LEXICAL_TRANSLATION_SCORER_INCLUDED

#include <boost/noncopyable.hpp>
#include <glog/logging.h>
#include <map>
#include <string>
#include <utility>
#include "tm.hpp"

class LexicalTranslationScorer : boost::noncopyable {
  public:
    LexicalTranslationScorer() : read_flag_(false) {}
    explicit LexicalTranslationScorer(std::string fname);
    double calc_lexical_trans_prob_s_t(const TM&, const DataForTM*) const;
    double calc_lexical_trans_prob_t_s(const TM&, const DataForTM*) const;

  private:
    std::map<std::pair<std::string, std::string>, double> lexical_translation_table_s_t_;
    std::map<std::pair<std::string, std::string>, double> lexical_translation_table_t_s_;
    bool read_flag_;
};

#endif
