/*
KyotoEBMT Example-Based Machine Translation System
Copyright (C) 2014 John Richardson, Fabien Cromieres, 
Toshiaki Nakazawa and Sadao Kurohashi

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

#include "oov_handler.hpp"
#include <glog/logging.h> 
#include <string>

std::string OOVHandler::query(const std::string &word, std::string &method) const {
    // try punctuation
    std::string punc_result = dic_punc_.query(word);
    if (punc_result != "") {
        method = "punc";
        LOG(INFO) << "OOV (punc): query=" << word << " result=" << punc_result;
        return punc_result;
    }
    // try dictionary lookup
    std::string dic_result = dic_words_.query(word);
    if (dic_result != "") {
        method = "dic";
        LOG(INFO) << "OOV (dic): query=" << word << " result=" << dic_result;
        return dic_result;
    }
    std::string unchanged = word;
    method = "unknown";
    LOG(INFO) << "OOV: query=" << word << " could not be handled, returned same string.";
    return unchanged;
}

