/*
KyotoEBMT Example-Based Machine Translation System
Copyright (C) 2014 John Richardson, Fabien Cromieres, 
Toshiaki Nakazawa and Sadao Kurohashi

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef OOV_HANDLER_HPP
#define OOV_HANDLER_HPP

#include <string>
#include "dictionary.hpp"
#include "params.hpp"

class OOVHandler {
  public:
    OOVHandler(std::string dic_punc_filename, std::string dic_words_filename) : 
            dic_punc_(dic_punc_filename), dic_words_(dic_words_filename) {}
    /// Default constructor (mainly for allowing instanciating Translator object without OOV for hypothesis input mode                
    OOVHandler() {}
    std::string query(const std::string &query, std::string &method) const;
    
  private:
    Dictionary dic_punc_;
    Dictionary dic_words_;
};

#endif
