/*
KyotoEBMT Example-Based Machine Translation System
Copyright (C) 2014 John Richardson, Fabien Cromieres, 
Toshiaki Nakazawa and Sadao Kurohashi

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

#include "para_sentence.hpp"
#include <vector>

/*
// obsolete
void ParaSentence::print_parallel_dtree() {
    VS s_tree_buffer, t_tree_buffer;
    std::vector<char> mark;
    s_dtree_.print_dtree(s_dtree_.root(), mark, s_tree_buffer);
    t_dtree_.print_dtree(t_dtree_.root(), mark, t_tree_buffer);

    int s_tree_buffer_size = s_tree_buffer.size();
    for (int s = 0; s < s_tree_buffer_size; s++) std::cout << s_tree_buffer[s] << std::endl;
    std::cout << std::endl;
    int t_tree_buffer_size = t_tree_buffer.size();
    for (int t = 0; t < t_tree_buffer_size; t++) std::cout << t_tree_buffer[t] << std::endl;
    std::cout << std::endl;

    // 並列に表示するには2バイト文字のチェックが必要
    // int max_length = 0;
    // for (int s = 0; s < s_tree_buffer.size(); s++) {
    //     if (max_length < s_tree_buffer[s].length()) max_length = s_tree_buffer[s].length();
    // }
    // cerr << max_length << endl;
    // for (int s = 0; s < s_tree_buffer.size() || s < t_tree_buffer.size(); s++) {
    //     if (s < s_tree_buffer.size()) cout << s_tree_buffer[s] << "    ";
    //     for (int t = 0; t < (max_length - s_tree_buffer[s].length()) * 2 + 4; t++) cout << " ";
    //     if (s < t_tree_buffer.size()) cout << t_tree_buffer[s] << "    ";
    //     cout << endl;
    // }
}
*/

void ParaSentence::print(std::ostream *os) const {
    *os << id_ << std::endl;
    s_dtree_.print(os);
    *os << std::endl;
    t_dtree_.print(os);
    *os << std::endl;
}
void ParaSentence::print(std::ostream *os, const DtreeNode *s_node_r, const DtreeNode *t_node_r, const int *s_bond, const int *t_bond) const {
    s_dtree_.print_dtree(os, s_node_r, s_bond);
    *os << std::endl;
    t_dtree_.print_dtree(os, t_node_r, t_bond);
    *os << std::endl;
}
std::ostream &operator<<(std::ostream &os, const ParaSentence &t) {
    t.print(&os);
    return os;
}

const Alignment* ParaSentence::get_alignment_s(const DtreeNode *w) const {
    for (std::vector<Alignment>::const_iterator it = s_t_match_.begin(); it != s_t_match_.end(); it++) {
        if (grep(w->num, it->p1).size() > 0) return &*it;
    }
    return NULL;
}

const Alignment* ParaSentence::get_alignment_t(const DtreeNode *w) const {
    for (std::vector<Alignment>::const_iterator it = s_t_match_.begin(); it != s_t_match_.end(); it++) {
        if (grep(w->num, it->p2).size() > 0) return &*it;
    }
    return NULL;
}
