# KyotoEBMT Example-Based Machine Translation System
# Copyright (C) 2014 John Richardson, Fabien Cromieres, 
# Toshiaki Nakazawa and Sadao Kurohashi

# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU Affero General Public License for more details.

# You should have received a copy of the GNU Affero General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.

def load_defaults(filename):
    input = {}
    defaults = {}
    data_set = ""
    default = ""
    with open(filename) as file_in:
        for line in file_in:
            if line.startswith("#"):
                continue
            if line.startswith("%"):
                data_set = line[1:].strip()
                defaults[data_set] = {}
                continue
            parts = line.strip().split("=")
            if len(parts) != 2:
                continue
            attribute, value = parts
            if value.startswith('"'):
                value = value[1:-1]
            else:
                value = int(value)
            if attribute == "DEFAULT":
                default = value
                input["DATA_SET"] = value
            else:
                defaults[data_set][attribute] = value
                if data_set == default:
                    input[attribute] = value
            #print attribute, data_set, value
    return input, defaults

def load_settings(filename):
    settings = {}
    with open(filename) as file_in:
        for line in file_in:
            if line.startswith("#"):
                continue
            parts = line.strip().split("=")
            if len(parts) != 2:
                continue
            attribute, value = parts
            if value.startswith('"'):
                value = value[1:-1]
            else:
                value = int(value)
            settings[attribute] = value
            #print attribute, value
    return settings
            
