# KyotoEBMT Example-Based Machine Translation System
# Copyright (C) 2014 John Richardson, Fabien Cromieres, 
# Toshiaki Nakazawa and Sadao Kurohashi

# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
# MA 02110-1301 USA

#!/usr/bin/env perl

use strict;
use utf8;

binmode STDIN, ":utf8";
binmode STDOUT, ":utf8";

while (<STDIN>) {
    chomp;
    if ($_ !~ /^\# S-ID/) {
	s/　/ /g;
	tr/[a-zA-Z0-9]/[ａ-ｚＡ-Ｚ０-９]/;
	tr/[\!\"\#\$\%\&\'\(\)\=\~\|\`\{\+\*\}\<\>\?\_\-\^\\\@\[\;\:\]\,\.\/\\]/[！”＃＄％＆’（）＝〜｜‘｛＋＊｝＜＞？＿−＾￥＠「；：」、．・￥]/;
	s/\&amp;/＆/g;
	s/\&lt;/＜/g;
	s/\&gt;/＞/g;
	s/\&apos;/’/g;
	s/\&quot;/”/g;
    }
    print "$_\n";;
}
